//+------------------------------------------------------------------+
//|                Orignal Code by Scorpion                          |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 White
#property indicator_color2 White


extern int Stoch1_K = 5;
extern int Stoch1_D = 3;
extern int Stoch1_Slowing = 3;
extern int Stoch2_K = 5;
extern int Stoch2_D = 3;
extern int Stoch2_Slowing = 3;
extern int Stoch2_TimeFrame = 240;
extern int PriceField = 0;
extern int Shift_Bars=0;
extern int Bars_Count= 10000;

//---- buffers
double v1[];
double v2[];
  
int init()
  {

   IndicatorBuffers(2);
   SetIndexArrow(0,217);
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,1);
   SetIndexDrawBegin(0,-1);
   SetIndexBuffer(0, v1);
   SetIndexLabel(0,"Buy");
   
   SetIndexArrow(1,218);
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,1);
   SetIndexDrawBegin(1,-1);
   SetIndexBuffer(1, v2);
   SetIndexLabel(1,"Sell");
 
   return(0);
  }

int start()
 {
  double Stoch1_Main, Stoch1_Signal, Stoch2_Main, Stoch2_Signal;
  double Stoch1_Main_2, Stoch1_Signal_2;
  int previous;
  int i;
  int shift;
  bool crossed_up, crossed_down;
  int counted_bars = IndicatorCounted();
  if (counted_bars > 0) counted_bars--;
  if (Bars_Count > 0 && Bars_Count <= Bars)
  {
    i = Bars_Count - counted_bars;
  }else{
    i = Bars - counted_bars;
  }
  
  while(i>=0)
   {
    shift = i + Shift_Bars;
    
    Stoch1_Main = iStochastic(NULL, 0, Stoch1_K, Stoch1_D, Stoch1_Slowing, 0, PriceField, 0, shift+1);
    Stoch1_Signal = iStochastic(NULL, 0, Stoch1_K, Stoch1_D, Stoch1_Slowing, 0, PriceField, 1, shift+1);
    
    Stoch1_Main_2 = iStochastic(NULL, 0, Stoch1_K, Stoch1_D, Stoch1_Slowing, 0, PriceField, 0, shift+2);
    Stoch1_Signal_2 = iStochastic(NULL, 0, Stoch1_K, Stoch1_D, Stoch1_Slowing, 0, PriceField, 1, shift+2);
    
    Stoch2_Main = iStochastic(NULL, Stoch2_TimeFrame, Stoch2_K, Stoch2_D, Stoch2_Slowing, 0, PriceField, 0, shift+1);
    Stoch2_Signal = iStochastic(NULL, Stoch2_TimeFrame, Stoch2_K, Stoch2_D, Stoch2_Slowing, 0, PriceField, 1, shift+1);
     
    crossed_up = (Stoch2_Main > Stoch2_Signal);
    crossed_down = (Stoch2_Main < Stoch2_Signal);
    
    if (Stoch1_Main > Stoch1_Signal && Stoch1_Main_2 < Stoch1_Signal_2 && crossed_up) {
      v1[i] = Open[shift];
    }else if(Stoch1_Main < Stoch1_Signal && Stoch1_Main_2 > Stoch1_Signal_2 && crossed_down) {
      v2[i] = Open[shift];
    }
    
    i--;
   }   
  return(0);
 }
 
//+------------------------------------------------------------------+